{
    "cover": {
        "about": "The CobWeb Internal Scanner (CWIS, pronounced see-wis) is a lightweight antivirus scanner application written in PHP and JS scripting languages. The scanner designed to detect trojans, viruses, malware and other threats within files uploaded to your system and in database contents.",
        "levels": {
            "header": "You have selected the “{{level}}” scan option",
            "1": "Fastest scan speed. Scans only documents and scripts filtered by extensions. Very Low probability of a false positive result. PHP scripts renamed as images will not be scanned.",
            "2": "Fast scan speed. Uses Heuristic Analyzer – detects unknown viruses. Effective filtering of binary files. Detects viruses in PHP scripts renamed as images. Provides optimal scan level and is appropriate for most users.",
            "3": "Slow scanning speed. Uses Heuristic Analyzer – detects unknown viruses. Effective filtering of binary files. Detects viruses in PHP scripts renamed as images. Potential malicious code check."
        },
        "heading": "Scan your server files"
    },
    "dashboard": {
        "alerts": {
            "cleanup": {
                "headline": "Your website has been hacked or blacklisted?",
                "submit": "Clean Up Your Site Now"
            },
            "email": {
                "headline": "Didn’t set an e-mail yet? For reports and security alerts please set a valid e-mail address",
                "input": "Enter your email address...",
                "submit": "Set an Email"
            },
            "update": {
                "headline": "Your CWIS Antivirus version {{current}} is outdated! Update to the latest version {{latest}}"
            }
        },
        "defender": {
            "footnote": "This feature is not fully compatible with websites on which CDN is enabled!"
        },
        "features": {
            "daysleft": "You have {{daysleft}} day(s) left for your Trial version",
            "upgrade": "Upgrade to our “Business” or “Premium” plan today",
            "basicscan": "Basic Check",
            "recommended": "Recommended Scan",
            "professional": "Professional Scan",
            "blacklist": "Blacklist Check",
            "database": "Database Scan",
            "qrescan": "Quick Rescan",
            "removal": "Virus Removal Tool",
            "scheduler": "Scheduled Scan",
            "defender": "Smart Protection",
            "emailing": "Email Security Alerts",
            "updates": "Automatic Updates",
            "support": "Premium Support",
            "protection": "Full Protection",
            "realtime": "24/7 Monitoring"
        },
        "license": {
            "title": "License",
            "business": {
                "header": "Upgrade to our “Business” plan today for only $6.9 per month:",
                "1": "Scanner scheduler’s settings",
                "2": "Upgrade to Premium support",
                "3": "SQL malware scan (CWIS exclusive function)",
                "4": "Scanner report export function",
                "5": "Professional scanner options",
                "submit": "Get Business"
            },
            "premium": {
                "header": "Upgrade to our “Premium” plan today for only $16.9 per month:",
                "1": "Full protection spec of the business suite +",
                "2": "24/7 100% protection – real time monitoring of your website",
                "3": "In case of an attack on your website our team will get an instant notification, thus we can protect, clean from threats (if necessary) and get your website back online in the shortest time possible",
                "submit": "Get Premium"
            }
        },
        "proFeatures": {
            "title": "Professional Features",
            "report": {
                "headline": "Get the full scan report (downloadable)",
                "info": "Option to access and review a detailed one-page report of the last scan results."
            },
            "scheduler": {
                "headline": "Configure scheduler settings for your scan",
                "info": "Built-in Cron Scheduler allows you to scan files on a schedule, fully automatically."
            },
            "suspicious": {
                "headline": "In-depth analysis of potentially malicious files",
                "info": "It is important to understand that the used signature and heuristic algorithms raise the level of malware diagnostics to almost 100%, but false positives that require analysis are inevitable."
            }
        },
        "scanReport": {
            "title": "Full Scan Report",
            "submit": "Open a detailed report"
        },
        "scanResults": {
            "title": "Scan Results",
            "submit": "Go to scan results"
        },
        "scanSummary": {
            "blacklist": {
                "title": "Blacklist Monitoring",
                "headline": "Domain blacklist check tool."
            },
            "malware": {
                "title": "Malware Scan Results",
                "headline": "Infected, dangerous and harmful files."
            },
            "security": {
                "title": "Security Hardening",
                "headline": "Server security hardening tips."
            },
            "spyware": {
                "title": "Detected Spyware And Adware",
                "headline": "Spyware and adware can pose significant risks to Internet users."
            },
            "suspicious": {
                "title": "Potentially Malicious",
                "headline": "Suspicious and potentially malicious files."
            },
            "updater": {
                "title": "Security Plugin Updates",
                "headline": "WordPress plugins and themes autoupdate settings.",
                "types": {
                    "plugins": "Total Plugins",
                    "themes": "Total Themes",
                    "secured": "Auto Updated",
                    "risk_low": "Low Risk",
                    "risk_medium": "Medium Risk",
                    "risk_high": "High Risk"
                },
                "submit": "Go to plugin page"
            },
            "vulner": {
                "title": "Detected Vulnerabilities",
                "headline": "Potentially vulnerable to attack (CMS, plugins etc). Please update to a more recent version."
            }
        }
    },
    "settings": {
        "alerts": {
            "saved": "Changes were successfully saved!",
            "notsaved": "Changes were not saved!"
        },
        "ajaxId": {
            "title": "Scanner identificator",
            "addon": "Scanner ID",
            "input": "Please enter a Scanner ID",
            "labels": {
                "error": "Please verify your network connection.",
                "invalid": "The Scanner ID that was entered is not valid.",
                "isEmpty": "Please enter a Scanner ID provided with your license.",
                "isShort": "Scanner ID is too short (must be at least 12 characters).",
                "null": "Please wait while data is loading...",
                "valid": "The Scanner ID is valid and accepted by the system."
            }
        },
        "email": {
            "title": "Email Settings",
            "sendalerts": "Send notifications and security alerts",
            "sendreports": "Automatically send scan reports via email",
            "email": "Email address to receive reports, notifications and security alerts",
            "footnote": "This feature is only available to our premium subscribers."
        },
        "license": {
            "modalTitle": "Authentication and Licensing",
            "title": "License Key",
            "addon": "License Key",
            "innew": "Enter your new License Key",
            "input": "Please enter a License Key",
            "labels": {
                "error": "Please verify your network connection.",
                "inactive": "The entered Key is not active or the License has expired.",
                "invalid": "The License Key that was entered is not valid.",
                "isEmpty": "Please enter a License Key provided with your license.",
                "isShort": "License Key is too short (must be at least 10 characters).",
                "null": "Please wait while data is loading...",
                "valid": "Your License Key is valid."
            },
            "success": {
                "free": "Thank you! You have successfully registered for a Free Trial.",
                "trial": "Thank you! You have activated a limited Trial version of WebDefender Security.",
                "business": "Thank you! You have a fully licensed Business version of WebDefender Security.",
                "professional": "Thank you! You have a fully licensed Professional version of WebDefender Security.",
                "premium": "Thank you! You have a fully licensed Premium version of WebDefender Security."
            },
            "trial": {
                "headline": "You can request a 30-day trial license key. Please fill out the form below:",
                "name": {
                    "addon": "Name",
                    "input": "Enter your full name..."
                },
                "email": {
                    "addon": "Email",
                    "input": "Enter your email address..."
                },
                "submit": "Get Trial License Key"
            },
            "types": {
                "free": "FREE version of WebDefender Security delivers the same performance as the licensed version. However, the Database Scan, Quick Rescan and Scheduled Scan features are disabled.",
                "trial": "You’ve activated the TRIAL version of WebDefender Security, which delivers you accesses to the full features set for a limited to a period of 30 days. When the end of the trial period, the Database Scan, Quick Rescan and Scheduled Scan features will be disabled.",
                "business": "Congratulations, you have a fully functional licensed version of WebDefender Security “Business”.",
                "professional": "Congratulations, you have a fully functional licensed version of WebDefender Security “Professional”.",
                "premium": "Congratulations, you have a fully functional licensed version of WebDefender Security “Premium”."
            },
            "userinfo": {
                "name": "Client Name",
                "company": "Company/Site",
                "domain": "Site Domain",
                "email": "Email Address",
                "product": "Licensed Product",
                "period": "License Period"
            }
        },
        "password": {
            "title": "Extra Features",
            "addon": "Password",
            "input": "Please enter the password",
            "labels": {
                "error": "Please verify your network connection.",
                "invalid": "The Password that was entered is not valid.",
                "isEmpty": "Please enter a Password provided with your license.",
                "isShort": "Password is too short (must be at least 12 characters).",
                "null": "Please wait while data is loading...",
                "valid": "The Password is valid and accepted by the system."
            }
        },
        "register": {
            "title": "Register for Free Version",
            "headline": "To sign up for trial version and start scan, please fill out the following form:",
            "submit": "Register Now"
        },
        "rest": {
            "nonce": "Your REST Nonce (beta feature, used for authentication in SaaS Dashboard)"
        },
        "scanner": {
            "title": "Scanner Settings",
            "autopath": "Auto-detect scan path (will be used the custom path if is switched off)",
            "scanpath": "Custom path (it is possible to specify multiple directories or files)",
            "database": "Perform database table scan",
            "level": "Scan level (Basic Check is the best for quick scanning)",
            "levels": {
                "1": "Basic Check",
                "2": "Recommended",
                "3": "Professional"
            },
            "sendmail": "Automatically send scan reports and notifications via email",
            "email": "Email address to receive reports and security alerts",
            "depth": "Recursive directory-scanning depth, use this setting for a limited scan or set to -1 for unlimited scan depth (default value)",
            "extskip": "File extensions to exclude from scanning (for example: mp3, pdf, ttf)",
            "secvuln": "Check PHP-files for potential security vulnerabilities using static code analysis (beta feature)",
            "reset": "Reset",
            "footnote": "The advanced scan and security features are part of the CWIS Business and Premium subscriptions."
        },
        "scheduler": {
            "title": "Scheduler Settings",
            "scanemail": "Email address to receive reports",
            "scanlast": "Last scan completed",
            "scanrepeat": "Next scan scheduled",
            "scannow": "Rescan Now!",
            "scanpath": "Scan path (can be left blank)",
            "database": "Scan database tables",
            "frequency": "Scan frequency",
            "frequencies": {
                "0": "One Time",
                "1": "Twice a Day",
                "2": "Daily",
                "3": "Weekly",
                "4": "Bi-Weekly",
                "5": "Monthly"
            },
            "level": "Scan level",
            "levels": {
                "1": "Basic Check",
                "2": "Recommended",
                "3": "Professional"
            },
            "scandirectory": "Server path(s) to user accounts or per-user Web directories (can be left blank)",
            "scandirexclude": "Top-level directories to exclude from scanning (for example: mail/new, tmp)",
            "footnote": "These scheduler features available only to premium subscribers."
        }
    }
}