{
    "defender": {
        "settings": {
            "title": "Defender Settings",
            "smartwaf": "Enable Smart Protection",
            "antibot": "Anti-Bot Protection – Monitors web traffic, filters out, and blocks bad bot traffic to a website",
            "antispam": "Anti-SPAM Protection – A unique automatic algorithm for diagnosing spam messages entered on your website",
            "bruteforce": "Brute Force Attack Protection – Bots detection system to prevent attempts to crack a password (login security)",
            "hidefunc": "Hide Function Protection – A passive security mechanism to prevent hacking using web scanners and bad bots",
            "ipfilter": {
                "allow": "IP Whitelist – Allows the listed IP addresses access to your website (unblocking)",
                "block": "IP Blacklist – Blocks the listed IP addresses from accessing your website content"
            }
        },
        "stats": {
            "title": "Defender Statistics"
        },
        "logs": {
            "title": "Defender Logs"
        },
        "footnote": "The Hide Function Protection feature is not fully compatible with websites on which CDN is enabled!"
    },
    "logviewer": {
        "title": "Log File Viewer",
        "label": "Log file (contains a list of files, errors or events)",
        "lines": "Number of lines from the end (0 for entire file)",
        "types": {
            "errors": "PHP Error Log",
            "prescan": "Prescan Log",
            "rescan": "Rescan Log"
        },
        "reload": "Reload File"
    },
    "quarantine": {
        "title": "Quarantine Manager",
        "headline": "The WebDefender Security includes a quarantine function. Whenever a scan detects a file that appears to be infected with a virus or malware, it encrypts the infected file and then isolates it (ie moves it to the local quarantine folder managed by the scanner). A file that is placed in quarantine is not deleted, which means that you can restore a backup version later, if necessary.",
        "file": {
            "name": "Name",
            "date": "Date",
            "size": "Size"
        },
        "restore": "Restore File"
    },
    "scanner": {
        "filter": {
            "title": "Filter The Scan Results",
            "match": {
                "literal": "The text will be used literally",
                "regexp": "Use the regex pattern syntax"
            },
            "filterexp": "Match regular expression",
            "filterinv": "Inverse/exclude matches"
        },
        "progress": {
            "title": "Scan Progress",
            "autopath": "Auto-detect path",
            "scanpath": "Path",
            "database": "Database",
            "level": "Level"
        },
        "results": {
            "title": "Scan Results",
            "areEmpty": "There are no results to display.",
            "seeMore": "Click on the particular category to view detailed scan results.",
            "summary": "Threats found",
            "types": {
                "Vulner": "Vulnerabilities",
                "Critical": "Critical",
                "Info": "Info",
                "Warnings": "Warnings",
                "Susp": "Suspicious"
            },
            "threats": {
                "vuln": "Vulnerabilities",
                "crit": "Malware and Viruses",
                "warn": "Spyware and Adware",
                "susp": "Professional Features"
            },
            "extskip": "Excluded file types",
            "more": "more details"
        },
        "statistics": {
            "summary": {
                "datetime": "Scan date",
                "elapsed": "Time elapsed",
                "files": "Files scanned",
                "last": "Last scanned",
                "path": "Scan path",
                "tables": "Databases scanned"
            },
            "rescan": {
                "progress": "Rescan: {{percent}}% complete"
            },
            "scan": {
                "files": "Files scanned: {{scanned}} of {{found}} ({{skipped}} skipped)",
                "directories": "Directories scanned: {{scanned}} of {{found}} ({{skipped}} skipped)",
                "progress": "Progress: {{percent}}% complete",
                "size": "Sum file size: {{size}}",
                "speed": "Scan speed: {{speed}} files/sec"
            },
            "time": {
                "elapsed": "Time elapsed: {{time}} sec",
                "left": "Time left: {{time}} sec (approx)"
            },
            "tables": {
                "scanned": "Database tables scanned: {{scanned}} of {{found}}",
                "size": "Database size: {{size}} ({{rows}} rows)"
            },
            "system": {
                "memory": "Memory usage: {{usage}} (max allowed {{limit}})",
                "load": "CPU load: {{load}}"
            },
            "NEM": "not enough memory",
            "NA": "N/A"
        }
    },
    "scheduler": {
        "title": "Calendar scheduler",
        "dates": {
            "label": "Scheduled dates",
            "start": "Start date",
            "end": "End date"
        },
        "directories": "Selected directories",
        "level": "Scan level",
        "state": "Task State",
        "states": {
            "inactive": "Inactive",
            "active": "Active",
            "dropped": "Dropped",
            "paused": "Paused",
            "completed": "Completed"
        },
        "buttons": {
            "create": "Create Task",
            "update": "Update Task",
            "remove": "Remove Task"
        }
    },
    "sitecheck": {
        "error": "Failed to load data from server!",
        "title": "Sitecheck Results",
        "title2": "Web Server Details",
        "title3": "Website Details",
        "title4": "Blacklist Status",
        "title5": "SSL Certificate",
        "api": {
            "date": "Cached results from {{date}}",
            "elapsed": "Time elapsed: {{elapsed}} sec"
        },
        "site": {
            "url": "Website",
            "hostname": "Hostname",
            "hostip": "IP address",
            "ssl": {
                "issuer": "Issuer",
                "validity": "Validity",
                "subject": "Subject",
                "summary": "It was found that your website doesn’t have an SSL certificate!",
                "detailed": "Starting January 2017, websites without an SSL certificate are shown as “insecure” in the Chrome web browser. It refers to further Google’s work in ensuring the entire Web soon runs on HTTPS only. Each website that is used for gathering and transmitting customer’s information (in particular E-commerce sites) should use an SSL certificate in order to guarantee the safety of this information.",
                "button": "Get an SSL Certificate"
            },
            "blacklist": {
                "listed": {
                    "0": "Domain clean by ",
                    "1": "Domain blacklisted by "
                }
            },
            "header": {
                "server": "Server type",
                "powered_by": "Powered by",
                "cdn": "CDN details"
            },
            "html": {
                "hrefs": "List of Links Found",
                "forms": "List of Forms Found",
                "scripts": "List of Scripts Included",
                "iframes": "List of Iframes Included",
                "links": "List of Resources Included"
            },
            "loadtime": "Load Time: {{time}} sec",
            "status": {
                "httpcode": "HTTP Status"
            },
            "whatcms": "Web Application Details"
        },
        "summary": {
            "labels": {
                "site": "Website",
                "url": "Site URL",
                "ssl": "SSL Certificate",
                "status": "Status",
                "webtrust": "Web Trust"
            },
            "status": {
                "0": "The Site Is Not Blocked",
                "1": "Site Potentially Harmful"
            },
            "ssl": {
                "0": "Disabled",
                "1": "Enabled",
                "fix": "Fix It"
            },
            "webtrust": {
                "0": "Currently, NOT Blacklisted",
                "1": "Blacklisted / Blocked",
                "blocked": "that means that one of the major search engines and/or security companies (such as Google, McAfee, Norton, etc) are blocking access to your website for security reasons",
                "checked": "{{count}} Blacklists Checked"
            },
            "results": {
                "summary": {
                    "0": "It seems that your website was not compromised.",
                    "1": "Your site appears to be hacked or compromised."
                },
                "detailed": {
                    "0": "If you still suspect that he might be infected, please contact us by email: cwis@cobweb-security.com. We can do a full manual audit of your site and clean any infection that our scanner has missed.",
                    "1": "Please note that: Hacked sites can lose almost 95% of the traffic in as little as 24 to 48 hours, if not fixed immediately you can lose your organic rankings as well as be blocked by Google, Bing or one of the other blacklists. Hacked sites can expose their visitor’s and customer’s private and financial information, and turn your website into a host for dangerous malware and illicit material. Please contact our team at cwis@cobweb-security.com to secure your site now."
                }
            },
            "buttons": {
                "0": "Protect Your Site Now",
                "1": "Clean Up Your Site Now"

            }
        }
    }
}