<?php
/**
 * Provide a admin application area view for the plugin
 *
 * This file is used to markup the admin-facing aspects of the plugin.
 *
 * @link       https://cobweb-security.com
 * @since      1.0.0
 *
 * @package    Cwis
 * @subpackage Cwis/admin/partials
 */
// Display inline script if WordPress 3.0+
if (function_exists('set_current_screen')) {
    ?>

    <!-- Custom JS -->
    <script>
        var doc_html = document.documentElement;
        doc_html.className += " site-background";
        doc_html.removeAttribute("ng-app");
        var doc_body = document.body;
        doc_body.removeAttribute("ng-app");
    </script>
<?php } ?>
    
<!-- Hotjar JS -->
<script>
    (function(h,o,t,j,a,r){
        h.hj=h.hj||function(){(h.hj.q=h.hj.q||[]).push(arguments)};
        h._hjSettings={hjid:841538,hjsv:6};
        a=o.getElementsByTagName('head')[0];
        r=o.createElement('script');r.async=1;
        r.src=t+h._hjSettings.hjid+j+h._hjSettings.hjsv;
        a.appendChild(r);
    })(window,document,'https://static.hotjar.com/c/hotjar-','.js?sv=');
</script>

<!-- Custom CSS -->
<style>
    .update-nag,
    #zing-warning,
    #wpbody-content>.notice,
    #wpbody-content>.updated,
    #wpbody-content>div>p {
        display: none;
    }

    /* Content */
    .site-main {
        direction: ltr;
        padding: 0 12px 0 2px;
    }
    html[dir=rtl] .site-main {
        padding: 0 2px 0 12px;
    }
    .site-footer {
        margin-bottom: 0;
    }
</style>

<!-- HTML5 shim and Respond.js for IE8 support of HTML5 elements and media queries -->
<!--[if lt IE 9]>
  <script src="https://oss.maxcdn.com/html5shiv/3.7.2/html5shiv.min.js"></script>
  <script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
<![endif]-->

<link rel="stylesheet" type="text/css" href="https://fonts.googleapis.com/css?family=Roboto:400,100,100italic,300,300italic,400italic,500,500italic,700,700italic,900italic,900&subset=latin,greek,greek-ext,vietnamese,cyrillic-ext,latin-ext,cyrillic">

<!-- Site -->
<div ng-app="CwisApp">
    <main ng-show="$pageFinishedLoading" class="site-main" 
          ng-class="{'menu-collapsed': $baNavbarService.isMenuCollapsed()}">
        <site-header></site-header>

        <div class="site-content">
            <ba-navbar></ba-navbar>
            <content-top></content-top>
            <div ask-for-support></div>
            <div ask-for-update></div>
            <div ui-view></div>
        </div>

        <site-footer></site-footer>
        <div back-top></div>
    </main>

    <div ng-show="!$pageFinishedLoading" id="preloader">
        <div></div>
    </div>
</div>