<input type="text" id="type-of-consent" class="regular-text" placeholder="<?php
esc_attr_e('Type of consent', CWIS_PLUGIN_SLUG);
?>">
<button class="button button-primary add-consent"><?php esc_html_e('Add consent', CWIS_PLUGIN_SLUG); ?></button>
<div id="consent-tabs">
    <?php
    $consent_types = get_option('gdpr_consent_types', array());
    if (empty($consent_types)) {
        $consent_types = $this->default_consent_types;
    }
    ?>
    <?php if (!empty($consent_types)) : ?>
        <?php foreach ($consent_types as $consent_key => $consent) : ?>
            <div class="postbox" id="consent-type-content-<?php echo esc_attr($consent_key); ?>">
                <h2 class="hndle"><?php echo esc_html($consent['name']); ?> <!--span>(id: <?php echo esc_html($consent_key); ?>)</span-->
                    <?php if ('privacy-policy' !== $consent_key) : ?>
                        <button class="notice-dismiss" type="button">
                            <span class="screen-reader-text"><?php echo esc_html__('Unregister this consent.', CWIS_PLUGIN_SLUG); ?></span>
                        </button>
                    <?php endif; ?></h2>
                <input type="hidden" name="<?php echo esc_attr('gdpr_consent_types'); ?>[<?php echo esc_attr($consent_key); ?>][name]" value="<?php echo esc_attr($consent['name']); ?>" />
                <div class="inside">
                    <table class="form-table">
                        <tr>
                            <th><label for="required-<?php echo esc_attr($consent_key); ?>"><?php
                                    esc_html_e('Required', CWIS_PLUGIN_SLUG);
                                    ?></label></th>
                            <td>
                                <?php if ('privacy-policy' === $consent_key): ?>
                                    <span><?php esc_html_e('Required', CWIS_PLUGIN_SLUG) ?></span>
                                    <input type="hidden" name="<?php echo esc_attr('gdpr_consent_types'); ?>[<?php echo esc_attr($consent_key); ?>][required]" id="required-<?php echo esc_attr($consent_key); ?>" value="1">
                                <?php else: ?>
                                    <label class="gdpr-switch">
                                        <input type="checkbox" name="<?php echo esc_attr('gdpr_consent_types'); ?>[<?php echo esc_attr($consent_key); ?>][required]" <?php
                                        checked(esc_attr($consent['required']), 1);
                                        ?> id="required-<?php echo esc_attr($consent_key); ?>">
                                        <span class="gdpr-slider round"></span>
                                    </label>
                                <?php endif; ?>
                            </td>
                        </tr>
                        <tr>
                            <th><label for="consent-description-<?php echo esc_attr($consent_key); ?>"><?php
                                    esc_html_e('Consent description', CWIS_PLUGIN_SLUG);
                                    ?></label></th>
                            <td><textarea name="<?php echo esc_attr('gdpr_consent_types'); ?>[<?php echo esc_attr($consent_key); ?>][description]" id="consent-description-<?php echo esc_attr($consent_key); ?>" cols="53" rows="3" required><?php echo esc_html($consent['description']); ?></textarea></td>
                        </tr>
                        <tr>
                            <th><label for="consent-registration-<?php echo esc_attr($consent_key); ?>"><?php
                                    esc_html_e('Registration message', CWIS_PLUGIN_SLUG);
                                    ?></label></th>
                            <td><textarea name="<?php echo esc_attr('gdpr_consent_types'); ?>[<?php echo esc_attr($consent_key); ?>][registration]" id="consent-registration-<?php echo esc_attr($consent_key); ?>" cols="53" rows="3" required><?php echo esc_html($consent['registration']); ?></textarea></td>
                        </tr>
                    </table>
                </div>
            </div>
        <?php endforeach ?>
    <?php endif ?>
</div>