<input type="text" id="cookie-tabs" class="regular-text" placeholder="<?php
esc_attr_e('Category name', CWIS_PLUGIN_SLUG);
?>">
<button class="button button-primary add-tab"><?php esc_html_e('Add tab', CWIS_PLUGIN_SLUG); ?></button>
<div id="tabs">
    <?php
    $cookie_types = get_option('gdpr_cookie_popup_content', array());
    if (empty($cookie_types)) {
        $cookie_types = $this->default_cookie_types;
    }
    ?>
    <?php if (!empty($cookie_types)) : ?>
        <?php foreach ($cookie_types as $cookie_key => $cookie) : ?>
            <div class="postbox" id="cookie-tab-content-<?php echo esc_attr($cookie_key); ?>">
                <h2 class="hndle"><?php echo esc_html($cookie['name']); ?>
                    <?php if ('strictly-necessary' !== $cookie_key) : ?>
                        <button class="notice-dismiss" type="button"><span class="screen-reader-text"><?php
                                esc_html_e('Remove this tab.', CWIS_PLUGIN_SLUG);
                                ?></span>
                        </button>
                    <?php endif; ?></h2>
                <input type="hidden" name="<?php echo esc_attr('gdpr_cookie_popup_content'); ?>[<?php echo esc_attr($cookie_key); ?>][name]" value="<?php echo esc_attr($cookie['name']); ?>" />
                <div class="inside">
                    <table class="form-table">
                        <tr>
                            <th><label for="always-active-<?php echo esc_attr($cookie_key); ?>"><?php
                                    esc_html_e('Always active', CWIS_PLUGIN_SLUG);
                                    ?></label></th>
                            <td>
                                <?php if ('strictly-necessary' === $cookie_key): ?>
                                    <span><?php esc_html_e('Required', CWIS_PLUGIN_SLUG) ?></span>
                                    <input type="hidden" name="<?php echo esc_attr('gdpr_cookie_popup_content'); ?>[<?php echo esc_attr($cookie_key); ?>][always_active]" id="always_active-<?php echo esc_attr($cookie_key); ?>" value="1">
                                <?php else: ?>
                                    <label class="gdpr-switch">
                                        <input type="checkbox" name="<?php echo esc_attr('gdpr_cookie_popup_content'); ?>[<?php echo esc_attr($cookie_key); ?>][always_active]" <?php
                                        checked(esc_attr($cookie['always_active']), 1);
                                        ?> id="always-active-<?php echo esc_attr($cookie_key); ?>">
                                        <span class="gdpr-slider round"></span>
                                    </label>
                                <?php endif; ?>
                            </td>
                        </tr>
                        <tr>
                            <th><label for="tab-how-we-use-<?php echo esc_attr($cookie_key); ?>"><?php
                                    esc_html_e('How we use', CWIS_PLUGIN_SLUG);
                                    ?></label></th>
                            <td><textarea name="<?php echo esc_attr('gdpr_cookie_popup_content'); ?>[<?php echo esc_attr($cookie_key); ?>][how_we_use]" id="tab-how-we-use-<?php echo esc_attr($cookie_key); ?>" cols="53" rows="3" required><?php echo esc_html($cookie['how_we_use']); ?></textarea></td>
                        </tr>
                        <tr>
                            <th><label for="cookies-used-<?php echo esc_attr($cookie_key); ?>"><?php
                                    esc_html_e('Cookies used by the site', CWIS_PLUGIN_SLUG);
                                    ?></label></th>
                            <td>
                                <textarea cols="53" rows="3" name="<?php echo esc_attr('gdpr_cookie_popup_content'); ?>[<?php echo esc_attr($cookie_key); ?>][cookies_used]" id="cookies-used-<?php echo esc_attr($cookie_key); ?>" required><?php echo esc_attr($cookie['cookies_used']); ?></textarea>
                                <br>
                                <span class="description"><?php
                                    esc_html_e('Comma separated list.', CWIS_PLUGIN_SLUG);
                                    ?></span>
                            </td>
                        </tr>
                        <tr>
                            <th><label for="hosts-<?php echo esc_attr($cookie_key); ?>"><?php
                                    esc_html_e('Third party domains', CWIS_PLUGIN_SLUG);
                                    ?></label></th>
                            <td>
                                <input type="text" id="hosts-<?php echo esc_attr($cookie_key); ?>" class="regular-text" placeholder="domain.com" />
                                <button class="button button-primary add-host" data-tabid="<?php echo esc_attr($cookie_key); ?>"><?php
                                    esc_html_e('Add', CWIS_PLUGIN_SLUG);
                                    ?></button>
                                <br>
                                <span class="description"><?php
                                    esc_html_e('Cookies that are set by a third party, like facebook.com.', CWIS_PLUGIN_SLUG);
                                    ?></span>
                            </td>
                        </tr>
                    </table>

                    <div class="tab-hosts" data-tabid="<?php echo esc_attr($cookie_key); ?>">
                        <?php if (isset($cookie['hosts']) && $cookie['hosts']) : ?>
                            <?php foreach ($cookie['hosts'] as $host_key => $host) : ?>
                                <div class="postbox">
                                    <h2 class="hndle"><?php echo esc_attr($host_key); ?><button class="notice-dismiss" type="button"><span class="screen-reader-text"><?php
                                                esc_html_e('Remove this domain.', CWIS_PLUGIN_SLUG);
                                                ?></span></button></h2>
                                    <input type="hidden" name="<?php echo esc_attr('gdpr_cookie_popup_content'); ?>[<?php echo esc_attr($cookie_key); ?>][hosts][<?php echo esc_attr($host_key); ?>][name]" value="<?php echo esc_attr($host_key); ?>" />
                                    <div class="inside">
                                        <table class="form-table">
                                            <tr>
                                                <th><label for="hosts-cookies-used-<?php echo esc_attr($host_key); ?>"><?php
                                                        esc_html_e('Cookies used', CWIS_PLUGIN_SLUG);
                                                        ?></label></th>
                                                <td>
                                                    <textarea cols="53" rows="3" name="<?php echo esc_attr('gdpr_cookie_popup_content'); ?>[<?php echo esc_attr($cookie_key); ?>][hosts][<?php echo esc_attr($host_key); ?>][cookies_used]" id="hosts-cookies-used-<?php echo esc_attr($host_key); ?>" required><?php echo esc_attr($host['cookies_used']); ?></textarea>
                                                    <br>
                                                    <span class="description"><?php
                                                        esc_html_e('Comma separated list.', CWIS_PLUGIN_SLUG);
                                                        ?></span>
                                                </td>
                                            </tr>
                                            <tr>
                                                <th><label for="hosts-cookies-optout-<?php echo esc_attr($host_key); ?>"><?php
                                                        esc_html_e('How to Opt Out', CWIS_PLUGIN_SLUG);
                                                        ?></label></th>
                                                <td>
                                                    <input type="text" name="<?php echo esc_attr('gdpr_cookie_popup_content'); ?>[<?php echo esc_attr($cookie_key); ?>][hosts][<?php echo esc_attr($host_key); ?>][optout]" value="<?php echo esc_attr($host['optout']); ?>" id="hosts-cookies-optout-<?php echo esc_attr($host_key); ?>" class="regular-text" required />
                                                    <br>
                                                    <span class="description"><?php
                                                        esc_html_e('Url with instructions on how to opt out.', CWIS_PLUGIN_SLUG);
                                                        ?></span>
                                                </td>
                                            </tr>
                                        </table>
                                    </div>
                                </div>
                            <?php endforeach; ?>
                        <?php endif; ?>
                    </div>
                </div>
            </div>
        <?php endforeach ?>
    <?php endif ?>
</div>