<?php

// ezscan7objrldgpfvmqkdthyuwi4x2x5
if (!defined('CWIS_SIGNATURE')) {
    header('HTTP/1.0 403 Forbidden');
    die('-1');
}

// Basic constants check
if (!defined('CWIS_ROOT_PATH') || !defined('CWIS_TEMP_PATH') || !defined('CWIS_WORK_PATH')) {
    header('HTTP/1.0 500 Internal Server Error');
    die('Cannot load bootstrap file!');
} else
// Validate working dir
if (!is_readable(CWIS_WORK_PATH)) {
    header('HTTP/1.0 500 Internal Server Error');
    die('Working directory is not readable. Please change permission for <b>rwxr-xr-x</b> or using command line <b>chmod +r directory_name</b>!');
}

// Authentication ID and password check
if (!defined('CWIS_AJAX_ID') || !defined('CWIS_AJAX_PASS') || strlen(CWIS_AJAX_ID) < 12 || strlen(CWIS_AJAX_PASS) < 12) {
    header('HTTP/1.0 403 Forbidden');
    die('Authentication ID and password should be 12 characters or more!');
}

// Require scanner defines
if (!require_once(CWIS_WORK_PATH . DIRECTORY_SEPARATOR . 'cwis-defines.php')) {
    header('HTTP/1.0 500 Internal Server Error');
    die('Cannot load defines file!');
}

// Include scanner "compat" functions
if (!require_once(CWIS_INCLUDES_PATH . DIRECTORY_SEPARATOR . 'cwis-compat.php')) {
    header('HTTP/1.0 500 Internal Server Error');
    die('Cannot load compat file!');
}

// The scanner cannot run on PHP-CGI!
if (!CWIS_IS_CLI && !get_server_env('HTTP_USER_AGENT')) {
    header('HTTP/1.0 500 Internal Server Error');
    die("Cannot run on PHP-CGI. Requires PHP as CLI!");
}

// Allow access from a local web-server
if (($http_origin = get_server_env('HTTP_ORIGIN')) && substr_count($http_origin, ':') > 1) {
    $http_origin_port = substr($http_origin, strrpos($http_origin, ':') + 1, 5);
    $allowed_port = is_numeric($http_origin_port) ? ':' . $http_origin_port : '';
    header('Access-Control-Allow-Origin: http://' . get_server_ip() . $allowed_port);
} else {
    header('Access-Control-Allow-Methods: GET, POST');
    header('Access-Control-Allow-Origin: ' . $http_origin);
}

// Check the access rights
$scanner_auth_id = filter_input_post('id');
$scanner_ajax_pass = filter_input_post('p');
if (!$scanner_auth_id && !$scanner_ajax_pass) {
    header('HTTP/1.0 403 Forbidden');
    die('Access forbidden!');
} elseif ($scanner_auth_id && !hash_equals(CWIS_AJAX_ID, $scanner_auth_id)) {
    header('HTTP/1.0 403 Forbidden');
    die('Incorrect scanner ID entered!');
} elseif ($scanner_ajax_pass && !hash_equals(CWIS_AJAX_PASS, $scanner_ajax_pass)) {
    header('HTTP/1.0 403 Forbidden');
    die('Incorrect password entered!');
}

// Require helpers and app files
require_file('cwis-helpers.php');
require_file('cwis-app.php');

// Check required classes
if (!class_exists('CwisApp')) {
    header('HTTP/1.0 500 Internal Server Error');
    die('Cannot load required app files!');
}

// Run application
$app = new CwisApp();
$app->construct(0, CWIS_SCAN_PATH);
$app->start();
