<?php

// ezscan7objrldgpfvmqkdthyuwi4x2x5
if (!defined('CWIS_SIGNATURE')) {
    header('HTTP/1.0 403 Forbidden');
    die('-1');
}

// Application name
define('CWIS_NAME', 'WebDefender Security');

// Local hour in 24-hour format, date('G') generates E_NOTICE
define('CWIS_LOCAL_HOUR', floor((time() % 86400) / 3600));

// Check if accessed from the the command-line interface (CLI)
define('CWIS_IS_CLI', php_sapi_name() === 'cli' || defined('STDIN'));

// Check if runned on PHP-CGI  (since v2.2.4.11)
define('CWIS_IS_CGI', CWIS_IS_CLI && getenv('REDIRECT_STATUS') === 'CGI');

// --- WORK-PATH-BASED ---
// Assets (since v2.2.5.4)
define('CWIS_ASSETS_PATH', CWIS_WORK_PATH . DIRECTORY_SEPARATOR . 'CWIS-ASSETS');

// Includes (since v1.9.4.7)
define('CWIS_INCLUDES_PATH', CWIS_WORK_PATH . DIRECTORY_SEPARATOR . 'CWIS-INCLUDES');

// Lists (since v1.9.8.9)
define('CWIS_LISTS_PATH', CWIS_WORK_PATH . DIRECTORY_SEPARATOR . 'CWIS-LISTS');

// --- TEMP-PATH-BASED ---
// Quarantine (since v1.7.6.9)
define('CWIS_QUARANTINE_PATH', CWIS_TEMP_PATH . DIRECTORY_SEPARATOR . 'CWIS-QUARANTINE');

// Results (since v1.9.3.1)
define('CWIS_RESULTS_PATH', CWIS_TEMP_PATH . DIRECTORY_SEPARATOR . 'CWIS-RESULTS');

// Tasks (since v2.2.5.7)
define('CWIS_TASKS_PATH', CWIS_TEMP_PATH . DIRECTORY_SEPARATOR . 'CWIS-TASKS');

// Whitefile (since v4.0.6)
define('CWIS_WHITEFILE_PATH', CWIS_TEMP_PATH . DIRECTORY_SEPARATOR . 'CWIS-WHITEFILE');

// URL of the remote storage directory
define('CWIS_REMOTE_DIR', 'http://downloads.cobweb-security.com/' . CWIS_SIGNATURE . '/%s');

// Report masks
define('CWIS_RMASK_PHPSIGN', 1);
define('CWIS_RMASK_SPAMLINKS', 2);
define('CWIS_RMASK_DOORWAYS', 4);
define('CWIS_RMASK_SUSP', 8);
define('CWIS_RMASK_FULL', // full-featured report
       CWIS_RMASK_PHPSIGN | CWIS_RMASK_SPAMLINKS | CWIS_RMASK_DOORWAYS | CWIS_RMASK_SUSP
);

// Define heuristics suspicious types
define('CWIS_SUSP_FILE_MTIME', 1); // suspicious mtime (greater than ctime)
define('CWIS_SUSP_FILE_PERM', 2); // suspicious permissions 
define('CWIS_SUSP_PHP_IN_UPLOAD', 4); // suspicious .php file in upload or image directory
//
// Doorways detection parameter
define('CWIS_MAX_ALLOWED_PHP_HTML_IN_DIR', 600);

// Maximum of external links to display
define('CWIS_MAX_EXTERNAL_LINKS', 100);

// Suspicious code preview length
define('CWIS_MAX_PREVIEW_LENGTH', 105);
