<?php

/**
 * The plugin guarder file
 *
 * @link              https://cobweb-security.com
 * @since             1.4.0
 * @package           Cwsd
 */
// Skip if accessed recursively
if (!defined('ABSPATH')) {
    define('ABSPATH', dirname(dirname(dirname(dirname(__FILE__)))) . '/');

    // Include the guarder and block user if not whitelisted
    require_once dirname(__FILE__) . '/includes/defender/class-guarder.php';
    $cwis_defender_guarder = new Cwis_Defender_Guarder();
    if (!$cwis_defender_guarder->is_client_whitelisted() &&
            !$cwis_defender_guarder->is_search_engine_bot()) {

        // Check for user IP in database
        if (false !== ($packed_entry = $cwis_defender_guarder->check_user_ip())) {
            $cwis_defender_guarder->block_user_access($packed_entry);
        }

        // Insert IP and block user
        $cwis_defender_guarder->block_user_ip();
    }
}