<?php

/**
 * The plugin router file
 *
 * @link              https://cobweb-security.com
 * @since             1.0.1
 * @package           Cwsd
 */
// Exit if accessed directly
defined('ABSPATH') OR exit;

// Include the guarder
require_once dirname(__FILE__) . '/includes/defender/class-guarder.php';
$cwis_defender_guarder = new Cwis_Defender_Guarder();

// Insert IP and block user if not whitelisted
if (@empty($_SERVER["QUERY_STRING"]) && !$cwis_defender_guarder->is_client_whitelisted() &&
        !$cwis_defender_guarder->is_search_engine_bot()) {
    $cwis_defender_guarder->block_user_ip();
}

// Check for user IP in database
if (false !== $cwis_defender_guarder->check_user_ip()) {
    $cwis_defender_guarder->block_user_access();
}

// Include the converter
require_once dirname(__FILE__) . '/includes/defender/class-converter.php';
$converter = new Cwis_Defender_Converter();
if (!$converter->process_router_request() || !$converter->output_file_contents()) {
    header('HTTP/1.1 404 Not Found');
    exit;
}
