<?php

/**
 * The class that defines the updater-specific config data.
 * 
 * @link       https://cobweb-security.com
 * @since      3.3.3.3
 *
 * @package    Cwis
 * @subpackage Cwis/includes/updater
 * @author     Cobweb Security <cwis@cobweb-security.com>
 */
class Cwis_Updater_Config
{

    /**
     * All types of Wordpress core updates.
     *
     * @since   3.3.3.3
     * @access  public
     * @var     array   $auto_core_update_types
     */
    public $auto_core_update_types = array(
        'dev'   => 0,
        'minor' => 0,
        'major' => 0
    );

    /**
     * Security risk levels. Data files should be placed in directories
     * "admin/data/plugins" and "admin/data/themes" accordingly.
     *
     * @since   3.3.3.3
     * @access  public
     * @var     array   $security_risk_levels
     */
    public $security_risk_levels = array(
        0 => array(
            'context'     => 'success',
            'title'       => 'Secured',
            'description' => 'Minimum security risk - automatic update is enabled'
        ),
        1 => array(
            'context'     => 'info',
            'title'       => 'Low Risk',
            'description' => 'Low security risk - automatic update is not mandatory'
        ),
        2 => array(
            'context'     => 'warning',
            'title'       => 'Medium Risk',
            'description' => 'Medium security risk - we recommend using the automatic update',
            'datafile'    => 'recommended.txt'
        ),
        3 => array(
            'context'     => 'danger',
            'title'       => 'High Risk',
            'description' => 'High security risk - we strongly recommend using the automatic update',
            'datafile'    => 'vulnerable.txt'
        )
    );

}
