<?php

/**
 * Fired when the plugin is uninstalled.
 *
 * For more information, see the following discussion:
 * https://github.com/tommcfarlin/WordPress-Plugin-Boilerplate/pull/123#issuecomment-28541913
 *
 * @link       https://cobweb-security.com
 * @since      1.0.0
 *
 * @package    Cwis
 */
// If uninstall not called from WordPress, then exit.
if (!defined('WP_UNINSTALL_PLUGIN')) {
    exit;
}

// Scanner options
delete_option('CWIS_AJAX_ID');
delete_option('CWIS_AJAX_PASS');
delete_option('CWIS_LAST_SCAN');

// Defender options
delete_option('CWIS_BFA_NONCE');
delete_option('CWIS_DEFENDER');

// GDPR options
delete_option('CWIS_GDPR_ENABLED');
delete_option('CWIS_GDPR_REQUESTS');

// Updater options
delete_option('CWIS_CORE_UPDATES');
delete_option('CWIS_PLUGIN_UPDATES');
delete_option('CWIS_THEME_UPDATES');

// REST options
delete_option('CWIS_REST_NONCE');
